


#include <audioresample/functable.h>
#include <stdio.h>
#include <math.h>



int
main (int argc, char *argv[])
{
  Functable *ft;
  int i;
  double width;
  double sum;
  int n;
  double rms;
  double expected_rms;

  ft = functable_new ();
  functable_set_offset (ft, -1);
  functable_set_multiplier (ft, 0.02);
  functable_set_length(ft, 100);

  width = 0.5;
  functable_calculate (ft, functable_func_sinc, &width);

  printf("comparing sinc functable\n");
  sum = 0;
  n = 1000;
  for(i=0;i<n;i++){
    double x;
    double fx;
    double gx;

    x = -1.0 + 0.002 * i;
    fx = functable_evaluate(ft, x);
    gx = sin(x)/x;

    sum += (fx - gx) * (fx - gx);
  }
  rms = sqrt (sum/n);
  expected_rms = 4.73424e-11;
  printf ("RMS difference: %g (expected %g)\n", rms, expected_rms);

  if (rms < 0.9 * expected_rms) return 1;
  if (rms > 1.1 * expected_rms) return 1;
  return 0;
}

